package com.scbfkj.uni.system;

import com.scbfkj.uni.service.ControlService;
import com.scbfkj.uni.service.DataProcessService;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.HashMap;
import java.util.Objects;

public class ScheduleTask implements Runnable {
    private String id; // 服务ID

    public String getId() {
        return id;
    }

    Integer loopCount;
    int count = 0;
    public LocalDateTime taskValid;
    public LocalDateTime taskInvalid;


    /**
     * @param id 任务ID
     */
    public ScheduleTask(String id, Integer loopCount, LocalDateTime taskValid, LocalDateTime taskInvalid) {
        this.id = id;
        this.loopCount = loopCount;
        this.taskValid = taskValid;
        this.taskInvalid = taskInvalid;
    }

    @Override
    public void run() {
        if (Objects.nonNull(taskInvalid) && taskInvalid.isBefore(LocalDateTime.now())) {
            try {
                ControlService.stop(id);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            return;
        }
        if (Objects.isNull(taskValid) || taskValid.isAfter(LocalDateTime.now())) {
            if (Objects.isNull(loopCount) || count < loopCount) {
                if (!Objects.isNull(loopCount))
                    count++;
                DataProcessService dataProcess =  ScheduleUtil.getordropInput(id);
                if (Objects.isNull(dataProcess) || Objects.nonNull(dataProcess.getErrorMessage())) {
//                 todo   LogUtils.log("run: 1", "-1",  null,"启动服务失败，获取采集对象异常:" + (Objects.isNull(dataProcess) ? "" : dataProcess.getErrorMessage()), id,"服务编号：" + id, null,null,null);//无条件记录数据接收日志
                    return;
                }
                try {
                    dataProcess.process(new HashMap<>() {{
                        put("dataContent", "1");
                        put("event", "1");
                    }});

                } catch (Exception e) {
//                    todo 日志
                }

            } else {
                try {
                    ControlService.stop(id);
                    count = 0;
                } catch (Exception e) {
//                    todo 日志
                }
            }
        }
    }


}
