package com.scbfkj.uni.system;

import com.scbfkj.uni.library.DataEncryptionUtil;
import com.scbfkj.uni.library.DataFormatUtil;
import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.service.DataProcessService;
import jakarta.annotation.PostConstruct;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;
import java.util.Map;


@Component
public class SystemInit {


    @Value("${db.center.config}")
    private String centerConfig;

    @Value("${db.security.config}")
    private String securityconfig;

    @Value("${app.security.enable:true}")
    private boolean enableSecurity;
    @Value("${app.container.code}")
    private String containerCode;


    @Value("${log.target}")
    private List<String> targets;


    @PostConstruct
    public void init() throws Exception {
        Config.containerCode = containerCode;
        Config.enable = enableSecurity;
        Config.centerConnectionStr = DataEncryptionUtil.decryptRSAByPrivateKey(centerConfig);
        Config.securityConnectionStr = DataEncryptionUtil.decryptRSAByPrivateKey(securityconfig);

//        日志配置初始化
        for (String targetStr : targets) {
            String target = DataEncryptionUtil.decryptRSAByPrivateKey(targetStr);
            Config.targets.add(target);
        }

        startService();
    }

    public void startService() throws Exception {
        String queryServiceInfos = "select * from serviceinfo where containercode=?";
        List<Map<String, Object>> serviceInfos = DataBase.query(Config.centerConnectionStr, queryServiceInfos, Collections.singletonList(new Object[]{Config.containerCode}));
        for (Map<String, Object> serviceInfo : serviceInfos) {
            String serviceId = serviceInfo.get("serviceid").toString();
            String serviceType = serviceInfo.get("servicetype").toString();
            String taskType = serviceInfo.get("tasktype").toString();
//
//            todo 启动服务

        }
    }
}
